<?php
//------------------------------------------------------------------------------------
//                                  COPYRIGHT NOTICE
//------------------------------------------------------------------------------------
//LAST POST - FORUMS
//------------------------------------------------------------------------------------
//The included php scripts (code) is the exclusive copyright of EIP Software LLC. 
//(http://www.eipsoftware.com). 
//
//EIP Software LLC grants holder a non-exclusive license and the use of the code is 
//to be used only in connection with the XenForo forum software. Any deviation or 
//violation of EIP Software LLC or XenForo terms of use will immediately 
//revoke any implied or explicitly stated rights granted to you to use the following 
//code.  The code is copyrighted and may not be copied, even if modified or merged 
//with other data or software.
//
//By using the code and XenForo forum software you agree to be bound by EIP 
//Software LLC's and XenForo Terms of Service as well as these 
//additional terms and conditions. 
//
//XenForo forum software's use of any kind of part or all of XenForo
//software requires a separate license from XenForo. You may not 
//commercially redistribute and or part of LAST POST - FORUMS or XenForo's forum
//software.
//
//This code is distributed in the hope that it will be useful, but WITHOUT ANY 
//WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
//PARTICULAR PURPOSE. завершенный!
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
//cls_ErrorHandler.php  handle any error processing.
//called by:    news.php, posts.php, photos.php
//inputs:       NONE 
//uses:         $_SESSION['debug_mode']            
//returns:      NONE
//outputs:      error message to $_SESSION['error_message']
//updates:      2009-09-24 :: mm :: original
//
//------------------------------------------------------------------------------------
//version:      1.0
//status:       CHECKED IN
//------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------------------------
//GLOBALS
//----------------------------------------------------------------------------------------------------------------------------
//session_start();
$_SESSION['debug_mode']=TRUE;                          //Turn DEBUG mode on and off

class ExceptionHandler extends Exception
{
    public function __construct($message, $code=0)
    {
        parent::__construct($message,$code);
    }
    
    /**
     * parse the error message that was generated.  Re-direct the user to the custom errorhandler webpage.
     * try and get the http_referer so the user can re-direct themselves
     * default out to standard exception class
     */
    public function ParseError($str_DebugMessage=NULL)
    {
        try
        {
            $_SESSION['error_message'] = "At " . date("m/d/Y H.i.s")  ." an unexpected error was generated. <br/>";
            
            if($_SESSION['debug_mode']==TRUE)       //write to the global session variable, details about the error that was generated
            {
                $_SESSION['error_message'].= "File: ". $this->getFile() . " :: Line: ".$this->getLine()."<br/>Err: ".$this->getMessage() ."<br/>";
                $_SESSION['error_message'].= (!$str_DebugMessage==NULL) ? "Additional info: " .$str_DebugMessage."<br/>" :"<br/>";
				$_SESSION['error_message'].= isset($_SESSION['debug_info']) ? "Debug Info: ".$_SESSION['debug_info']."<br/>" :"<br/>";
            }
            $html_reflink = isset($_SERVER['HTTP_REFERER']) ? htmlspecialchars($_SERVER['HTTP_REFERER']) : "";
            $html_reflink = (strlen($html_reflink > 1)) ? "<a href='" .$html_reflink."'>Return to the prior page</a>" : "Please use the back button to return to the prior page."; 
            $_SESSION['error_message'].= "<br/><br/>" . $html_reflink;
            
            echo($_SESSION['error_message']);										//spit back the error message
            //header('Location: http://www.yourdomain.com/errorhandler.php');		//need to make custom error handler 
			exit();				//stop processing
        }
        catch(Exception $e)
        {
            return("<br/>Error -999FFF1<br/>A critical error has occured at " . date("m/d/Y H.i.s")."<br/>");
			exit();
        }  
    }
}
?>