<?php
//------------------------------------------------------------------------------------
//                                  COPYRIGHT NOTICE
//------------------------------------------------------------------------------------
//LAST POST - FORUMS
//------------------------------------------------------------------------------------
//The included php scripts (code) is the exclusive copyright of EIP Software LLC. 
//(http://www.eipsoftware.com). 
//
//EIP Software LLC grants holder a non-exclusive license and the use of the code is 
//to be used only in connection with the XenForo forum software. Any deviation or 
//violation of EIP Software LLC or XenForo terms of use will immediately 
//revoke any implied or explicitly stated rights granted to you to use the following 
//code.  The code is copyrighted and may not be copied, even if modified or merged 
//with other data or software.
//
//By using the code and XenForo forum software you agree to be bound by EIP 
//Software LLC's and XenForo Terms of Service as well as these 
//additional terms and conditions. 
//
//XenForo forum software's use of any kind of part or all of XenForo
//software requires a separate license from XenForo. You may not 
//commercially redistribute and or part of LAST POST - FORUMS or XenForo's forum
//software.
//
//This code is distributed in the hope that it will be useful, but WITHOUT ANY 
//WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
//PARTICULAR PURPOSE. завершенный!
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
//cls_lastposts.php:    run the querty to get the last posts and build an html table
//called by:            getForumLastPost.php
//inputs:               NONE
//uses:                 qry_lastposts.php
//returns:
//outputs:              html
//updates:      		2010-02-25 :: mm :: original
//------------------------------------------------------------------------------------
//version:              1.01
//status:               CHECKED IN
//------------------------------------------------------------------------------------

class getLastPosts
{
	private static $userOptions;	//get the user options
	//private $qry;					//PDO or sql object
	private static $arr_Results;	//hold the query results
	private static $arr_Needle;		//array to hold values to search for
	private static $arr_NewValue;	//array to hold the replacement values
	private $html_Table;			//hold the html string

	public function __construct()
	{
		self::$userOptions = get_option("eipForumOptions");
		(self::$userOptions["forumDBConn"] == "PDO") ? include_once dirname( __FILE__ ) . '/cls_mypdo.php' : include_once dirname( __FILE__ ) . '/cls_runquery.php';
		self::$arr_Needle 	= array(' ','/','\\','.','?','"','!','\'','(',')');		//values to search for in the title
		self::$arr_NewValue = array('-','-','-' ,'' ,'' ,'' ,'' ,''  ,'' ,'' );		//replacement values
	}

	/**
	 * 
	 * Get the thread data from the Xenforo database
	 * @return array table data
	 */
	public function getForumData()
	{
		switch (self::$userOptions["forumDBConn"])
		{
			case "SQL" :
			{
				$rq = new eipRunQuery(self::$userOptions);
				//run query to get the listing of private nodes	
				self::$userOptions["excludeNodes"] = self::getPrivateForums($rq->getQueryResults(qry_PrivateNodeList()));
				//run querty to get the last posts
				self::$arr_Results = $rq->getQueryResults(qry_LastPost(self::$userOptions));			
				break;
			}
			case "PDO" :
			{
				$pd = new eipPDO(self::$userOptions);
				self::$userOptions["excludeNodes"] = self::getPrivateForums($pd->getResults(Array('sql'=>qry_PrivateNodeList())));
				self::$arr_Results = $pd->getResults(Array('sql'=>qry_LastPost(self::$userOptions)));
				break;
			}
			default :
			{
				return("Unsupported Data Connection selected, Enter in SQL or PDO");	
			}
		}
		unset($rq);
		unset($pd);
		return($this->BuildTableTitle() . $this->BuildTable());
	}
	
	/**
	 * 
	 * Merge the private node list with the excluded node list from user options
	 * @param array $privateNodes
	 * @return string
	 */
	private function getPrivateForums($privateNodes)
	{
		$nodeList = "-1";
		if(is_array($privateNodes))
		{
			foreach($privateNodes as $feRow)
			{
				$nodeList .= "," . $feRow['content_id'];
			}
		}
		if(strlen(self::$userOptions['forumNodeList'])>0)
		{
			$nodeList .= "," . self::$userOptions['forumNodeList'];
		}
		return($nodeList);
	}
	/**
	 * builds the html for the table title
	 * @return string html for table title
	 */
	private function BuildTableTitle()
	{
		// /forums/index.php?find-new/threads
		$html_lnk = new Link(array('href'=>self::$userOptions['forumDomain'].'/index.php?find-new/threads',
									'text'=>self::$userOptions['forumTitle']));
		$str_html = '<span class="eiplastpost">'. $html_lnk->getElement() . '</span>';
		return($str_html);
	}
	/**
	 * 
	 * Build the table that shows the last posts table
	 * @return string containing html
	 */
	private function BuildTable()
	{
	/*	here is where you can customize the what the table output will look like for your own needs
		use a foreach loop to loop through each row.  The sql results are stored in the array self::$arr_Results
		
		the query returns the following fields for you to use. 
			thread_id,			-- id of the thread
			title, 				-- thread title
			threadstarter,  	-- username of who started the thread
			replies,			-- number of replies to the thread
			lastpostid,			-- id of the last message posted
			lastposter,			-- username of the last person to reply to the the thread
			last_post_date		-- date of the last reply to the thread
		If you want to bring back more fields the query is located in the /qry/qry_lastposts.php file
	*/
		$html_Tbl = new Table(Array("id"=>"tbl1","class"=>"tblforums","columns"=>3,"text"=>""));
		//push the table header cells into the obj
			array_push($html_Tbl->Cells, New Cell(array('header'=>'true','id'=>'HdrCol1',"class"=>"col1","text"=>"Thread / Thread Starter")));		
			array_push($html_Tbl->Cells, New Cell(array('header'=>'true','id'=>'HdrCol2',"class"=>"col2","text"=>"Replies")));
			array_push($html_Tbl->Cells, New Cell(array('header'=>'true','id'=>'HdrCol3',"class"=>"col3","text"=>"Last Post / Member")));
		//cycle through the query results pushine into the Cells collection
		foreach(self::$arr_Results as $feRow)
		{
			//$scrubbedTitle = self::$userOptions['forumDomain'] . "index.php?threads/" . str_replace($needle,$newval,$feRow['title']) . "." . $feRow['thread_id']."/";
			$scrubbedTitle = self::scrub_title($feRow['title'], $feRow['thread_id']);
			$html_Lnk	= New Link(array("href"=>$scrubbedTitle, "text"=>substr($feRow['title'],0,self::$userOptions["forumThreadLen"])));
			$html_Post	= New Link(array("href"=>$scrubbedTitle."page-".ceil($feRow['replies']/20)."#post-".$feRow['lastpostid'], "text"=>$feRow['replies']));
		//push onto the array, the table cells
			array_push($html_Tbl->Cells, 
							New Cell(array("class"=>"thread",	"text"=>$html_Lnk->getElement())), //$feRow['title'])),
							New Cell(array("class"=>"posts",	"text"=>$html_Post->getElement())), //$feRow['replies'])),
							New Cell(array("class"=>"lastdate",	"text"=>date('M d, Y  H:i',$feRow['lastpostdate']))),
							New Cell(array("class"=>"user",		"text"=>$feRow['threadstarter'])),
							New Cell(array("class"=>"blank",	"text"=>"&nbsp;")),
							New Cell(array("class"=>"lastuser",	"text"=>$feRow['lastposter']))
					);

		}
		return($html_Tbl->getElement());
	}

	private function scrub_title($currentValue, $id)
	{
		return (self::$userOptions['forumDomain'] . "index.php?threads/" .  str_replace(self::$arr_Needle, self::$arr_NewValue, $currentValue). "." . $id ."/" );
	}

}

?>
