<?php
//------------------------------------------------------------------------------------
//                                  COPYRIGHT NOTICE
//------------------------------------------------------------------------------------
//LAST POST - FORUMS
//------------------------------------------------------------------------------------
//The included php scripts (code) is the exclusive copyright of EIP Software LLC. 
//(http://www.eipsoftware.com). 
//
//EIP Software LLC grants holder a non-exclusive license and the use of the code is 
//to be used only in connection with the XenForo forum software. Any deviation or 
//violation of EIP Software LLC or XenForo terms of use will immediately 
//revoke any implied or explicitly stated rights granted to you to use the following 
//code.  The code is copyrighted and may not be copied, even if modified or merged 
//with other data or software.
//
//By using the code and XenForo forum software you agree to be bound by EIP 
//Software LLC's and XenForo Terms of Service as well as these 
//additional terms and conditions. 
//
//XenForo forum software's use of any kind of part or all of XenForo
//software requires a separate license from XenForo. You may not 
//commercially redistribute and or part of LAST POST - FORUMS or XenForo's forum
//software.
//
//This code is distributed in the hope that it will be useful, but WITHOUT ANY 
//WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
//PARTICULAR PURPOSE. завершенный!
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
//cls_xfconfig.php:		read the xenforo config file
//called by:            posts.php
//inputs:               NONE
//uses:                 /library/config.php
//returns:
//outputs:              NONE
//updates:      		2010-02-25 :: mm :: original
//------------------------------------------------------------------------------------
//version:              1.01
//status:               CHECKED IN
//------------------------------------------------------------------------------------
class eipLastPostxfconfig
{
	private static $xfDBConfig;			//store the XF DB config settings
	
	public function __construct($filename)
	{	
		try
        {
			if(is_readable($filename))
			{
				include_once($filename);
				self::$xfDBConfig = $config;
			}
			else
			{
				throw new ExceptionHandler("The Xenforo config file not located");
			}
        }
		catch(ExceptionHandler $e)
        {
            $e->ParseError("The Xenforo config file not located.<br/>");
        }
	}
	public function getValue($value,$subvalue)
	{
		if(array_key_exists($value, self::$xfDBConfig) && array_key_exists($subvalue, self::$xfDBConfig[$value]))
		{
			return(self::$xfDBConfig[$value][$subvalue]);
		}
	}
}
?>