<?php
/** 
 * @package Get_Forum_Last_Post
 * @name Get Forum Last Post
 * @copyright eipSoftware LLC
 * @author eipSoftware LLC  http://www.eipsoftware.com
 * @version 1.1.0
------------------------------------------------------------------------------------
                                  COPYRIGHT NOTICE
------------------------------------------------------------------------------------
LAST POST - FORUMS
------------------------------------------------------------------------------------
The included php scripts (code) is the exclusive copyright of EIP Software LLC. 
(http//:www.eipsoftware.com). 

EIP Software LLC grants holder a non-exclusive license and the use of the code is 
to be used only in connection with the XenForo forum software. Any deviation or 
violation of EIP Software LLC or XenForo terms of use will immediately 
revoke any implied or explicitly stated rights granted to you to use the following 
code.  The code is copyrighted and may not be copied, even if modified or merged 
with other data or software.

By using the code and XenForo forum software you agree to be bound by EIP 
Software LLC's and XenForo Terms of Service as well as these 
additional terms and conditions. 

XenForo forum software's use of any kind of part or all of XenForo
software requires a separate license from XenForo. You may not 
commercially redistribute and or part of LAST POST - FORUMS or XenForo's forum
software.

This code is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE. завершенный!
------------------------------------------------------------------------------------

------------------------------------------------------------------------------------
*/
if(is_admin())
{
	add_action('admin_init', 'eipRegisterSettings');
	add_action("admin_menu", "eipLastPostsAdminMenu");
}

	/**
	 * settings page and variables to be defined
	 */
	function eipRegisterSettings()
	{
		$setting = Array("forumDBConn","forumDomain","forumDirectory","forumPosts","forumUserPosts","forumLookBack","forumNodeList","forumUserGroup","forumTitle","forumThreadLen");
		$default = Array("SQL","/forums/","/var/www/forums/library/config.php",6,5,30,0,0,"Table Title",30);
		add_settings_section("eipSettingsSection", "Xenforo Last Posts", "eipLastPostsInfo", "eipLP");
		//Xenforo settings
		add_settings_field("eipLPConnection",	"Database Connection", 	"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[0],'defaultval'=>$default[0]));
		add_settings_field("eipLPDomain",		"Forum Domain", 		"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[1],'defaultval'=>$default[1]));
		add_settings_field("eipLPDirectory",	"Forum Directory", 		"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[2],'defaultval'=>$default[2]));
		add_settings_field("eipLPPosts",		"Forum Posts", 			"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[3],'defaultval'=>$default[3]));
		
		//qry settings
		add_settings_field("eipLPUserPosts",	"Required User Posts",		"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[4],'defaultval'=>$default[4]));
		add_settings_field("eipLPMaxDays",		"Maximum Days to Look Back","eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[5],'defaultval'=>$default[5]));

		//visual options
		add_settings_field("eipLPExcludeNodes",	"Nodes to Exclude",			"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[6],'defaultval'=>$default[6]));
		add_settings_field("eipLPExcludeUsers",	"User Groups to Exclude",	"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[7],'defaultval'=>$default[7]));
		add_settings_field("eipLPTitle",		"Table Title", 				"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[8],'defaultval'=>$default[8]));
		add_settings_field("eipLPThreadLen",	"Thread Title Length",		"eipOptionTextBox",	"eipLP", "eipSettingsSection", array('setting'=>$setting[9],'defaultval'=>$default[9]));
		register_setting("eipLastPostOptionGroup", "eipForumOptions","eipScrubInput");
	}
	/**
	 * Define the paramets for the options page in the admin menu
	 */
	function eipLastPostsAdminMenu()
	{
		add_options_page("eip Last Posts", "Last Posts", "administrator", "eipLP", "eipBuildSettings");	
	}
	/**
	 * Header Description
	 */
	function eipLastPostsInfo()
	{
		return("<p>Enter in the settings for the Xenforo forum<br/> 
		<li><b>Database Connection:</b> Value can be <b>SQL</b> or <b>PDO</b>. If unsure enter in <b>SQL</b></li>
		<li><b>Forum Domain: </b>Enter the value <b>AFTER</b> your internet domain, i.e. <b>/forums/</b></li>
		<li><b>Forum Directory: </b>The complete file path to your Xenforo config.php file i.e. <b>/var/www/forums/library/config.php</b></li>
		<li><b>Forum Posts: </b>How many posts to retrieve from the forum, maximum of 99. i.e. <b>6</b></li>
		<li><b>Required User Posts: </b>How many posts must a user have before showing up in the table. i.e. <b>5</b></li>
		<li><b>Maximum Days to Look Back: </b>Maximum days to look back for old posts, show posts newer than X days ago. i.e. <b>30</b></li>
		<li><b>Nodes to Exclude: </b>A comma separated list for nodes you don't want to show posts. If you want to include all nodes enter 0. i.e. <b>12,17,18</b></li>
		<li><b>User Groups to Exclud: </b>A comman separated list for user groups to exclude, i.e. banned users. If you want to include all user groups enter 0. i.e. <b>1,4</b></li>
		<li><b>Table Title: </b>Title to put above the table</li>
		<li><b>Thread Title Length: </b>Maximum length of a thread title. i.e. <b>30</b></li>
		</p>");
	} 
	/**
	 * Build up the form to enter in the settings
	 */
	function eipBuildSettings()
	{
		$html_string	=	'
			<div class = "wrap">
				<h3>Get Last Forum Posts Options</h3>
				<form method="post" action="options.php">'.
					api_settings_fields("eipLastPostOptionGroup").
					api_do_settings_sections("eipLP").
					'
					<input class="button-primary" name="Submit" type="submit" value="Save Changes" />
				</form>
			</div>
		';
		echo($html_string);
	}
	/**
	 * Create the input boxes on the admin settings page
	 * @param string $setting which setting to retrieve from the database
	 * @return string containing html for input box
	 */
	function eipOptionTextBox($arg)
	{
		$currentOptions = get_option("eipForumOptions");
		$optVal = (is_array($currentOptions) && array_key_exists($arg['setting'], $currentOptions)) ? $currentOptions[$arg['setting']] : $arg['defaultval'];
		$html_string = '
			<input id="eip'.$arg['setting'].'" name="eipForumOptions['. $arg['setting'] .']" size="40" type="text" value="'.$optVal. '" />';
		return($html_string);
	}
	/**
	 * Sanitize and validate input. Accepts an array, return a sanitized array.
	 * @param array $userInput
	 */
	function eipScrubInput($userInput)
	{	
		foreach($userInput as $feUI)
		{
			$userInput[$feUI] = wp_filter_nohtml_kses($feUI);
		}
		$userInput['forumDBConn'] = ($userInput['forumDBConn'] == "SQL" || $userInput['forumDBConn'] == "PDO") ? $userInput['forumDBConn'] : "SQL";
		$userInput['forumPosts'] = eipFilterNumeric($userInput['forumPosts'], 1, 99, 10);
		$userInput['forumLookBack'] = eipFilterNumeric($userInput['forumLookBack'], 1, 365, 30);
		$userInput['forumThreadLen'] = eipFilterNumeric($userInput['forumThreadLen'], 4, 128, 30);
		return ($userInput);
	}
	/**
	 * Sanitize numeric values
	 * @param string $currentValue
	 * @param int $minValue  Minimum value 
	 * @param int $maxValue	 Maximum value
	 * @param int $replacementValue DefaultValue if the value not between the min and max 
	 */
	function eipFilterNumeric($currentValue,$minValue,$maxValue,$replacementValue)
	{
		$newVaule = (is_numeric($currentValue)) ? intval($currentValue) : $replacementValue;
		$newVaule = (($newVaule < $minValue) || ($newVaule > $maxValue)) ? $replacementValue : $newVaule;
		return($newVaule); 
	}

//------------------------------------------------------------------------------------
//                                SUPPORT FUNCTIONS
//------------------------------------------------------------------------------------	
	/**
	 * replaces WP fx settings_fields($option_group) 
	 * Output nonce, action, and option_page fields for a settings page.
	 * @param string $option_group A settings group name.  This should match the group name used in register_setting().
	 */
	function api_settings_fields($option_group) 
	{
		$html_string = '<input type="hidden" name="option_page" value="' . esc_attr($option_group) . '" />
						<input type="hidden" name="action" value="update" />'.
						wp_nonce_field("$option_group-options","_wpnonce",TRUE,FALSE);
		return($html_string);
	}
	/**
	 * replaces the WP fx do_settings_sections($page)
	 * Prints out all settings sections added to a particular settings page
	 * @param string $page The slug name of the page whos settings sections you want to output
	 */
	function api_do_settings_sections($page) 
	{
		global $wp_settings_sections, $wp_settings_fields;
		$html_string = "";
		if ( !isset($wp_settings_sections) || !isset($wp_settings_sections[$page]) )
		{
			return;
		}

		foreach ( (array) $wp_settings_sections[$page] as $section ) 
		{
		if ( $section['title'] )
			$html_string .= "<h3>{$section['title']}</h3>\n";
		$html_string .=	call_user_func($section['callback'], $section);
		if ( !isset($wp_settings_fields) || !isset($wp_settings_fields[$page]) || !isset($wp_settings_fields[$page][$section['id']]) )
		{
			continue;
		}
		$html_string .= '<table class="form-table">';
		$html_string .= api_do_settings_fields($page, $section['id']);
		$html_string .= '</table>';
		}
		return ($html_string);
	}
	/**
	 * Replace the WP fx do_settings_fields
	 * Print out the settings fields for a particular settings section
	 * @param string $page Slug title of the admin page who's settings fields you want to show.
	 * @param section $section Slug title of the settings section who's fields you want to show.
	 */
	function api_do_settings_fields($page, $section) 
	{
		global $wp_settings_fields;
		$html_string = "";
		if (!isset($wp_settings_fields) || !isset($wp_settings_fields[$page]) || !isset($wp_settings_fields[$page][$section]) )
		{
			return;
		}

		foreach ( (array) $wp_settings_fields[$page][$section] as $field ) 
		{
			$html_string .= '<tr valign="top">';
			if ( !empty($field['args']['label_for']))
			{
				$html_string .= '<th scope="row"><label for="' . $field['args']['label_for'] . '">' . $field['title'] . '</label></th>';
			}
			else
			{
				$html_string .= '<th scope="row">' . $field['title'] . '</th>';
			}
			$html_string .=  '
					<td>'.
						call_user_func($field['callback'], $field['args']) .'
					</td>
				</tr>';
		}
		return ($html_string);
	}
?>