<?php
//------------------------------------------------------------------------------------
//                                  COPYRIGHT NOTICE
//------------------------------------------------------------------------------------
//LAST POST - FORUMS
//------------------------------------------------------------------------------------
//The included php scripts (code) is the exclusive copyright of EIP Software LLC. 
//(http://www.eipsoftware.com). 
//
//EIP Software LLC grants holder a non-exclusive license and the use of the code is 
//to be used only in connection with the XenForo forum software. Any deviation or 
//violation of EIP Software LLC or XenForo terms of use will immediately 
//revoke any implied or explicitly stated rights granted to you to use the following 
//code.  The code is copyrighted and may not be copied, even if modified or merged 
//with other data or software.
//
//By using the code and XenForo forum software you agree to be bound by EIP 
//Software LLC's and XenForo Terms of Service as well as these 
//additional terms and conditions. 
//
//XenForo forum software's use of any kind of part or all of XenForo
//software requires a separate license from XenForo. You may not 
//commercially redistribute and or part of LAST POST - FORUMS or XenForo's forum
//software.
//
//This code is distributed in the hope that it will be useful, but WITHOUT ANY 
//WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
//PARTICULAR PURPOSE. завершенный!
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
//qry_lastposts.php
//called by:    cls_lastpost.php
//inputs:   
//uses:                    
//returns:      $qry_sql	//string holding the sql query
//outputs:      
//updates:      2010-02-25 :: mm :: original
//              
//------------------------------------------------------------------------------------
//version:              1.0
//status:               CHECKED IN
//------------------------------------------------------------------------------------
function qry_LastPost($userOptions)
{
	try
	{
		$qry_sql = 	" 	SELECT 	thread.thread_id,
								thread.title, 
								thread.username				as threadstarter,
								thread.reply_count			as replies,
								thread.last_post_id			as lastpostid,
								thread.last_post_username	as lastposter,
								thread.last_post_date		as lastpostdate
								
						FROM 	xf_thread					as thread
								inner join xf_user 			as usr
								on thread.user_id = usr.user_id

						WHERE 	thread.discussion_state = 1
								AND usr.message_count >= " . $userOptions['forumUserPosts'] . "
								AND node_id NOT IN  (" . $userOptions['excludeNodes'] . ")
								AND thread.last_post_date >=UNIX_TIMESTAMP(DATE_SUB(NOW(),INTERVAL " . $userOptions['forumLookBack'] . " DAY))
								AND usr.user_group_id NOT IN (" . $userOptions['forumUserGroup'] .")  
						ORDER BY last_post_date DESC
					";		
		$qry_sql .= ($userOptions['forumPosts']>=1 && $userOptions['forumPosts']<=100) ? 
					" LIMIT 0," .  $userOptions['forumPosts']
					:" LIMIT 0,10";
		return($qry_sql);
	}
    catch(ExceptionHandler $e)
    {
        $e->ParseError($qry_sql);
    }
}
?>
